/* 
 * © 2007-2008 MySQL AB, 2008-2009 Sun Microsystems, Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
#ifndef _MODEL_LAYER_IMPL_H_
#define _MODEL_LAYER_IMPL_H_

#include <mdc.h>
#include <grtpp.h>

#include <grtpp_undo_manager.h>

#include "grts/structs.model.h"

#include "wbpublic_public_interface.h"

#include "model_object_impl.h"

  
class WBPUBLICBACKEND_PUBLIC_FUNC model_Layer::ImplData : public model_Object::ImplData
{
  typedef model_Object::ImplData super;
  
  friend class ViewBase;
  
protected:
  mdc::AreaGroup *_area_group;

  mdc::CanvasView *get_canvas_view() const;

  void layer_bounds_changed(const mdc::Rect &rect);
  void interactive_layer_resized(const mdc::Rect &rect);

  virtual bool is_realizable();

  void member_changed(const std::string &name, const grt::ValueRef &ovalue);

public:
  ImplData(model_Layer *owner);

  virtual ~ImplData();

  void raise_figure(const model_FigureRef &figure);
  void lower_figure(const model_FigureRef &figure);

public:  
  mdc::AreaGroup *get_area_group() const { return _area_group; }
  virtual mdc::CanvasItem *get_canvas_item() const { return _area_group; }
  
  virtual void render_mini(mdc::CairoCtx *cr);
  virtual bool realize();
  virtual void unrealize();

private:
  model_Layer *self() const { return (model_Layer*)_self; }
};


#endif // _MODEL_LAYER_IMPL_H_
